#/usr/bin/perl
# VobSub .raw to .srt converter, version 1.0
# (c)2006 Ilya Zverev
$fps = 30000.0/1001.0; # NTSC 29.970
#$fps = 25.0; # PAL 25

my $stream = '';
while(<>) {
	chomp;
	if(/^[0-9a-f ]+$/i) {
		s/^\s*(.+?)\s*$/\1 /;
		s/([0-9a-f][0-9a-f]) /chr(hex('0x'.$1) & 0x7F)/gei;
		$stream .= $_;
	}
}

my $cnt = 1;
while($stream =~ /(\x14\x20\x14\x20.+?\x14\x2F\x14\x2F)/gcs) {
	my $sub = $1;
	my $starttime = pos($stream);
	$stream =~ /\x14[,\/]\x14[,\/]/gc;
	my $endtime = pos($stream);
	pos($stream) = $starttime;
	
	$sub =~ s/\x14[p-vP]\x14[p-vP]/\n/g;
	$sub =~ s/\x00//g;
	$sub =~ s/\x14.//g;
	$sub =~ s/\x12\x29//g;
	$sub =~ s/\x11\x37/#/g;
	$sub =~ s/(\x11[rp]){2}/\n/g;
	$sub =~ s/\x11.//g;
	$sub =~ s/\x13\x70//g;
	$sub =~ s/^\n+//g;
	$sub =~ s/\n\n/\n/g;
	print $cnt++, "\n", postotime($starttime), " --> ", postotime($endtime), "\n$sub\n\n";
}

sub postotime {
	my $pos = shift @_;
	my $time = int(500*$pos/$fps); #  
	my $msec = $time%1000;
	my $sec = int($time/1000)%60;
	my $min = int($time/60000)%60;
	my $hour = int($time/3600000);
	return sprintf "%02d:%02d:%02d,%03d", $hour, $min, $sec, $msec;
}